﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using System.Data.SqlClient;

/*******************************************************
 
 ** 作者: SoFlash - 博客园  http://www.cnblogs.com/longwu
 
 ** 描述: FrmLog.cs 用于 查看用于登录日志 

 ******************************************************/

namespace 电影记录管理系统
{
    public partial class FrmLog : Form
    {
        public FrmLog()
        {
            InitializeComponent();
        }

        //连接字符串 获取配置文件里的连接路径
        static string connStr = ConfigurationManager.ConnectionStrings["str"].ConnectionString;

        public void FrmLog_Load(object sender, EventArgs e)
        {
            //将当前用户的登录信息添加到DataGridView里面
            AddLog();
            //将数据显示到DataGridView上
            ShowMsg();
        }

        public void AddLog()
        {
            string sql = "insert into Log(User_Name,UserType,Situation,Time)values(@User_Name,@UserType,@Situation,@Time) ";

            //简单判断下 插入的数据是否为空 如果为空 则弹出提示
            if (FrmLogin.Uid == "" || FrmLogin.Situation == "" || FrmLogin.Time.ToString() == "")
            {
                MessageBox.Show("数据不能为空!");
                return;
            }
            //向数据库里插入参数
            SqlParameter[] param ={
                                      new SqlParameter("@User_Name",FrmLogin.Uid),
                                      new SqlParameter("@UserType",FrmLogin.UserType),
                                      new SqlParameter("@Situation",FrmLogin.Situation),
                                      new SqlParameter("@Time",FrmLogin.Time)
                                  };
            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand cmd = new SqlCommand(sql, conn);
            conn.Open();
            cmd.Parameters.AddRange(param);
            int n = cmd.ExecuteNonQuery();
            conn.Close();
        }

        //窗体加载自动从数据库获取数据并显示在datagridview的方法
        public void ShowMsg()
        {
            string showSql = "select * from Log";
            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand cmd = new SqlCommand(showSql, conn);
            DataTable dt = new DataTable();
            SqlDataAdapter sda = new SqlDataAdapter(cmd);
            sda.Fill(dt);
            dgvLog.DataSource = dt;

        }

        //获取当前系统时间的方法
        public void GetExitTime()
        {
            //直接将当前时间赋给FrmLogin的Time变量
            FrmLogin.Time = DateTime.Now;
            //将当前"退出"字符串赋给FrmLogin.Situation
            FrmLogin.Situation = "退出";

        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            //调用获取当前退出时间的方法
            GetExitTime();
            //将当前用户的登录信息添加到DataGridView里面
            AddLog();
            //直接退出系统
            Application.Exit();
        }

        private void btnBack_Click(object sender, EventArgs e)
        {
            FrmMain main = new FrmMain();
            main.Show();
            this.Close();
        }

        private void btnQuery_Click(object sender, EventArgs e)
        {
            string showSql = "";

            if (txtQuery.Text.Trim() == "")
            {

                //执行查询语句
                showSql = "select * from Log";
            }
            else
            {
                //全局搜索
                showSql = "select * from Log where(Id like'%" + txtQuery.Text.Trim() + "%')or(UserType like'%" + txtQuery.Text.Trim() + "%')or(User_Name like'%" + txtQuery.Text.Trim() + "%')or(Situation like'%" + txtQuery.Text.Trim() + "%')or(Time like'%" + txtQuery.Text.Trim() + "%')";
            }

            SqlConnection conn = new SqlConnection(connStr);
            SqlCommand cmd = new SqlCommand(showSql, conn);
            DataTable dt = new DataTable();
            SqlDataAdapter sda = new SqlDataAdapter(cmd);
            sda.Fill(dt);
            dgvLog.DataSource = dt;
        }
    }
}
