﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

/*******************************************************
 
 ** 作者: SoFlash - 博客园  http://www.cnblogs.com/longwu
 
 ** 描述: FrmMain.cs  主窗体 用于衔接各项功能窗体

 ******************************************************/

namespace 电影记录管理系统
{
    public partial class FrmMain : Form
    {
        public FrmMain()
        {
            InitializeComponent();
        }

        private void tsbManager_Click(object sender, EventArgs e)
        {
            //new一个Manger窗体的对象
            FrmManager manager = new FrmManager();
            //转入FrmManager窗体
            manager.Show();
            //隐藏当前窗体
            this.Hide();
        }

        private void tsbPwdChange_Click(object sender, EventArgs e)
        {
            //同理
            FrmPwdChange pwdChange = new FrmPwdChange();
            pwdChange.Show();
            this.Hide();
        }

        private void tsbLogin_Click(object sender, EventArgs e)
        {
            //调用FrmLog窗体 获取当前时间退出的方法
            FrmLog log = new FrmLog();
            log.GetExitTime();

            //方法调用
            //将当前用户的登录信息添加到DataGridView里面
            log.AddLog();

            //同理
            FrmLogin login = new FrmLogin();
            login.Show();
            this.Hide();
        }

        private void tsbExit_Click(object sender, EventArgs e)
        {
            //调用FrmLog窗体 获取当前时间退出的方法
            FrmLog log = new FrmLog();
            log.GetExitTime();

            //方法调用
            //将当前用户的登录信息添加到DataGridView里面
            log.AddLog();

            //直接退出应用程序
            Application.Exit();

        }

        private void tsbLog_Click(object sender, EventArgs e)
        {
            FrmLog log = new FrmLog();
            log.Show();
            this.Hide();
        }

        //当窗体加载的时候 自动运行
        private void FrmMain_Load(object sender, EventArgs e)
        {
            //------------------------------新增代码----------------------------------//
            //这里 新增来一个用户类型 判断  FrmLogin.UserType
            //将当前登录用户名和登录时间赋给label的text属性
            //并在当前主界面窗体加载的时候 显示在label框上
            lblCurrentUser.Text = "当前登录用户为:" + FrmLogin.Uid + " 用户类型 " + FrmLogin.UserType + "  登录时间为:" + FrmLogin.Time;
            //------------------------------新增代码----------------------------------//

            //------------------------------新增代码----------------------------------//
            //给当前用户打招呼 
            //这里通过获取当前用户电脑上的时间 以及判断登录用户的类型 来给不同类型的用户打招呼  
            // 定义整型变量 intTime 来获取 用户电脑上的具体小时数 然后在如下进行判断
            int intTime = FrmLogin.Time.Hour;
            //获取FrmLogin窗体的全局变量 UserType 用户类型, 用于一下给不同类型的用户打招呼
            string uType = FrmLogin.UserType;
            //在凌晨0-6点的时候
            if (intTime >= 0 && intTime < 6)
            {
                if (uType == "Administrator")
                    lblSayHi.Text = "尊敬的  " + FrmLogin.Uid + " 深夜了,该休息了!";
                else if (uType == "NormalUser")
                    lblSayHi.Text = "亲爱的  " + FrmLogin.Uid + "凌晨了,要赶紧休息哦!";
            }
            //早上6点-中午12点的时候
            else if (intTime >= 6 && intTime < 12)
            {
                if (uType == "Administrator")
                    lblSayHi.Text = "尊敬的  " + FrmLogin.Uid + "  早上好!";
                else if (uType == "NormalUser")
                    lblSayHi.Text = "亲爱的  " + FrmLogin.Uid + " 早上好!";
            }
            //中午12点-下午6点的时候
            else if (intTime >= 12 && intTime < 18)
            {
                if (uType == "Administrator")
                    lblSayHi.Text = "尊敬的  " + FrmLogin.Uid + " 下午好!";
                else if (uType == "NormalUser")
                    lblSayHi.Text = "亲爱的  " + FrmLogin.Uid + " 下午好!";
            }
            //晚上
            else if (intTime >= 18 && intTime < 24)
            {
                if (uType == "Administrator")
                    lblSayHi.Text = "尊敬的  " + FrmLogin.Uid + " 晚上好!";
                else if (uType == "NormalUser")
                    lblSayHi.Text = "亲爱的  " + FrmLogin.Uid + " 晚上好!";
            }
            else //否则 默认为 
                lblSayHi.Text = "欢迎使用 电影记录管理系统" + FrmLogin.Uid;
            //------------------------------新增代码----------------------------------//

            //------------------------------新增代码----------------------------------//
            //判断用户类型 并给用户设置功能权限
            if (uType == "NormalUser")
            {
                tsbRegistration.Enabled = false;
                tsbLog.Enabled = false;
            }
            //------------------------------新增代码----------------------------------//
        }
          
        private void tsbRegistration_Click(object sender, EventArgs e)
        {
            //new一个 用户注册窗体对象
            FrmRegistration registration = new FrmRegistration();
            //显示 用户注册窗体
            registration.Show();
            //隐藏当前窗体(主界面)
            this.Hide();
        }

    }
}
